#include <SPI.h>         // needed for Arduino versions later than 0018
#include <Ethernet.h>
#include <EthernetUdp.h>         // UDP library from: bjoern@cs.stanford.edu 12/30/2008      
#include <avr/wdt.h>      // library watchdog

//variable pour la gestion du temps
long currentMillis;
long interval = 4000;
long lastMillis = 0;

byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};
IPAddress ip(192, 168, 0, 230);
byte subnet[] = {
  255, 255, 255, 0
};
unsigned int localPort = 8888;      // local port to listen on

// the next two variables are set when a packet is received
byte remoteIP[4];        // holds received packet's originating IP
unsigned int remotePort; // holds received packet's originating port

// buffers for receiving and sending data
char packetRecu[UDP_TX_PACKET_MAX_SIZE]; //buffer to hold incoming packet,
char  packetEnvoi[] = "";       // a string to send back
int ip2[4];                     // pour afficher l'ip dans la console
String recu = "";               //pour convertir en string les char reçut
char etat_do [7] = "";

EthernetUDP Udp;
void setup() {
  // start the Ethernet and UDP:
  Ethernet.begin(mac, ip);
  Udp.begin(localPort);

  Serial.begin(9600);
  // Relais
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  // init : mets toutes les pins à l'état haut car transistor vers relais inverse l'état
  digitalWrite(2, HIGH);
  digitalWrite(3, HIGH);
  digitalWrite(4, HIGH);
  digitalWrite(5, HIGH); 
}

void loop() {
  // if there's data available, read a packet
  int packetSize = Udp.parsePacket();
  if (packetSize) {
    Serial.print("Received packet of size ");
    Serial.println(packetSize);
    Serial.print("From ");
    IPAddress remote = Udp.remoteIP();
    for (int i = 0; i < 4; i++) {
      Serial.print(remote[i], DEC);
      if (i < 3) {
        Serial.print(".");
      }
    }
    Serial.print(", port ");
    Serial.println(Udp.remotePort());
    // read the packet into packetBufffer
    Udp.read(packetRecu, UDP_TX_PACKET_MAX_SIZE);
    Serial.println("Contents:");
    Serial.println(packetRecu);
    //------------------------------------------------------------------
    //------------------------------------------------------------------
    String recu =  packetRecu;
    if (recu == "connexion")
    {
      char packetEnvoi[] = "Connection OK";
      Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
      Udp.write(packetEnvoi);
      Udp.endPacket();
    }
    //-WatchDog-----------------------------------------------------------------
     if (recu.startsWith("wdt1"))
    {     
      wdt_enable(WDTO_8S);     // Pour un time-out à 8 secondes  
    }
    if (recu.startsWith("wdt0"))
    {     
      wdt_disable();   
    }    
    if (recu.startsWith("wdt2"))
    {     
      wdt_reset();   
    }
    //------------------------------------------------------------------
    if (recu.startsWith("do_high"))
    {
      if (recu.substring(7,8) == "1")
      {
        digitalWrite(2, LOW);
      }
      if (recu.substring(8,9) == "1")
      {
        digitalWrite(3, LOW);
      }
            if (recu.substring(9,10) == "1")
      {
        digitalWrite(4, LOW);
      }
            if (recu.substring(10,11) == "1")
      {
        digitalWrite(5, LOW);
      }   
    }
    //------------------------------------------------------------------
    if (recu.startsWith("do_high3"))
    {
      digitalWrite(3, LOW);
      char packetEnvoi[] = "Digital Output2 = LOW";
      Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
      Udp.write(packetEnvoi);
      Udp.endPacket();
    }
    //------------------------------------------------------------------

    //------------------------------------------------------------------
    if (recu.startsWith("do_low"))
    {
      digitalWrite(2, HIGH);
      digitalWrite(3, HIGH);
      digitalWrite(4, HIGH);
      digitalWrite(5, HIGH);
    }
    //------------------------------------------------------------------

  }//fin de if(packetSize)

  //------------------------------------------------------------------


  //------------------------------------------------------------------
  currentMillis = millis();
  if (currentMillis - lastMillis > interval)
    send_new_val();

  delay(10);
}//fin de void loop


void send_new_val() {

  lastMillis = currentMillis;// remize a zero du timer
  //------------------------------------------------------------------

  char str[5] ;// max 1023 = 4 char + char null \0

  String ana_1_val = itoa(analogRead(A0), str, 10); // transformation décimal -> chaine de char

  String ana_1 = ("AI_1=" + ana_1_val); //ajoute a la chaine "AI_1" pour connaitre l'analog input
  char AI_1[15];//déclare un buffer
  ana_1.toCharArray(AI_1, 15);//convertion de la chaine en array de char max 14 char

  Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
  Udp.write(AI_1);
  Udp.endPacket();
  //------------------------------------------------------------------

  delay(50);
  String ana_2_val = itoa(analogRead(A1), str, 10); // transformation décimal -> chaine de char

  String ana_2 = ("AI_2=" + ana_2_val); //ajoute a la chaine "AI_2" pour connaitre l'analog input
  char AI_2[15];//déclare un buffer
  ana_2.toCharArray(AI_2, 15);//convertion de la chaine en array de char max 14 char

  Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
  Udp.write(AI_2);
  Udp.endPacket();
  //------------------------------------------------------------------

  delay(50);
  String ana_3_val = itoa(analogRead(A2), str, 10); // transformation décimal -> chaine de char
  String ana_3 = ("AI_3=" + ana_3_val); //ajoute a la chaine "AI_3" pour connaitre l'analog input
  char AI_3[15];//déclare un buffer
  ana_3.toCharArray(AI_3, 15);//convertion de la chaine en array de char max 14 char

  Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
  Udp.write(AI_3);
  Udp.endPacket();
  //------------------------------------------------------------------

  delay(50);
  String ana_4_val = itoa(analogRead(A3), str, 10); // transformation décimal -> chaine de char
  String ana_4 = ("AI_4=" + ana_4_val); //ajoute a la chaine "AI_4" pour connaitre l'analog input
  char AI_4[15];//déclare un buffer
  ana_4.toCharArray(AI_4, 15);//convertion de la chaine en array de char max 14 char

  Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
  Udp.write(AI_4);
  Udp.endPacket();
  //------------------------------------------------------------------

  delay(50);
  String ana_5_val = itoa(analogRead(A4), str, 10); // transformation décimal -> chaine de char
  String ana_5 = ("AI_5=" + ana_5_val); //ajoute a la chaine "AI_5" pour connaitre l'analog input
  char AI_5[15];//déclare un buffer
  ana_5.toCharArray(AI_5, 15);//convertion de la chaine en array de char max 14 char

  Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
  Udp.write(AI_5);
  Udp.endPacket();
  //------------------------------------------------------------------

}//fin void send_new_val
